-- Common Dialog
-- ask_user()

    -- returns text or -1

without warning

include dialog.e

global function ask_user( sequence title, sequence prompt, sequence val )
    
    integer keyPress
    object result

    -- put stuff in the box    
    new_dialog( title, 0, 0, 46, 7, {} )

    -- populate dialog
    add_control( 1, LABEL, prompt, 2, 2, 0, 0, {} )
    add_control( 2, SLE, "", 3, 2, 42, 0, {} )
    add_control( 3, BUTTON, "&OK", 5, 3, 8, 0, {DEFAULT_BUTTON, FOCUS} )
    add_control( 4, BUTTON, "&Cancel", 5, 19, 10, 0, {CANCEL_BUTTON} )

    -- put default value into sle
    set_attrib( 2, DATA, val )

    -- display the objects
    run_dialog()

    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        -- return value in reply
        result = get_attrib( 2, DATA )
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result


end function
