-- Example #2: Simple Dialog
-- Ask the user if they like pizza
-- Uses loop test instead of run_dialog()

include dialog.e    -- dialog tools

function ask_pizza_2()

    integer result
    
    -- create the dialog
    new_dialog("Yes or No?", 0, 0, 36, 6, {} )
    
    -- define controls    
    add_control( 1, LABEL,  "Do you like pizza?", 2, 2, 0, 0, {} )
    add_control( 2, BUTTON, "&Yes", 4, 2, 7, 0, {} )
    add_control( 3, BUTTON, "&No", 4, 12, 8, 0, {} )
    add_control( 4, BUTTON, "&Cancel", 4, 23, 10, 0, {CANCEL_BUTTON} )
            
    show_dialog()      -- set up and display the dialog    

    -- loop until exit state changes
    while get_dialog( EXIT_STATE ) = MORE do    -- until the user exits
        edit_dialog()                           -- process keys
    end while
            
    -- determine result    
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1     -- pressed Esc or Cancel
    elsif get_dialog( FOCUS ) = 2 then
        result = 1      -- Yes
    else
        result = 0      -- No
    end if             

    -- remove dialog
    hide_dialog()
    
    -- return result
    return result
                
end function


-- run the code
    integer answer
    answer = ask_pizza_2()

