-- Example of using a list

    -- returns text or -1

without warning

include dialog.e

function ask_pizza()
    
    integer keyPress
    object result

    -- put stuff in the box    
    new_dialog( "Pick a Pizza", 0, 0, 35, 13, {} )

    -- populate dialog
    add_control( 1, LIST, "&Pizzas:", 4, 1, 30, 6, {} )
    add_control( 2, BUTTON, "&OK", 11, 4, 8, 0, {DEFAULT_BUTTON, FOCUS} )
    add_control( 3, BUTTON, "&Cancel", 11, 19, 10, 0, {CANCEL_BUTTON} )

    -- populate the list
    set_attrib( 1, ITEMS, { "Pepperoni",
                            "Sausage",
                            "Cheese",
                            "Anchovie"} )

    -- display the objects
    run_dialog()

    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        -- return value in reply
        result = list_selected_text( get_control( 1 ) )
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result


end function

-- run the dialog

    object result

    result = ask_pizza()

    if graphics_mode(-1) then end if

    clear_screen()

    if compare( result, -1 ) != 0 then
        puts( 1, "You said " & result & ".\n" )
    else
        puts( 1, "You cancelled the dialog.\n" )
    end if
