-- Example of using a list

    -- returns text or -1

without warning

include dialog.e

function ask_pizza()
    
    integer keyPress
    object result

    -- put stuff in the box    
    new_dialog( "Pick a Pizza Topping", 0, 0, 35, 8, {} )

    -- populate dialog
    add_control( 1, CHECK, "&Sausage", 2, 6, 0, 0, {} )
    add_control( 2, CHECK, "&Pepperoni", 3, 6, 0, 0, {} )
    add_control( 3, CHECK, "&Ground Beef", 4, 6, 0, 0, {} )
    add_control( 4, BUTTON, "&OK", 6, 8, 8, 0, {DEFAULT_BUTTON} )
    add_control( 5, BUTTON, "&Cancel", 6, 20, 10, 0, {CANCEL_BUTTON} )

    -- display the objects
    run_dialog()

    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        result = {}

        -- sausage?
        if get_attrib( 1, CHECKED ) then
            result = append( result, "Sausage" )
        end if

        -- pepperoni?
        if get_attrib( 2, CHECKED ) then
            result = append( result, "Pepperoni" )
        end if

        -- ground beef?
        if get_attrib( 3, CHECKED ) then
            result = append( result, "Ground Beef" )
        end if
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result


end function

-- run the dialog

    object result

    result = ask_pizza()

    if graphics_mode(-1) then end if

    clear_screen()

    if compare( result, -1 ) != 0 then
        if length( result ) = 0 then
            puts( 1, "You picked none.\n" )
        else
            puts( 1, "You picked " )
            for i = 1 to length( result ) do
                -- selection
                puts( 1, result[i] )

                -- syntax
                if i = length( result )         then puts( 1, ".\n" )
                elsif i = length( result ) - 1  then puts( 1, " and " )
                else                                 puts( 1, ", " )
                end if
            end for
        end if
    else
        puts( 1, "You cancelled the dialog.\n" )
    end if
