-- no_pp.e
-- Dummy functions for using the editor without PP.

-- not the real pp.e file
global constant PP_LOADED = 0

global function preprocess( sequence fileName, integer verbose )

    -- needs to exist; warns that is not loaded

    message_box( "Editor", {
        "You do not have the Euphoria Pre-Processor option loaded.",
        "",
        "To use the Euphoria Pre-Processor, you must:             ",
        "                                                         ",
        "   1. Add the file PP.E to your directory.               ",
        "                                                         ",
        "   2. In EE.EX, replace:   'include no_pp.e'             ",
        "                   with:   'include pp.e'.               ",
        "                                                         ",
        " For more information, refer to the README.TXT file.     ",
        "                                                         " } )

    return { 0, fileName }

end function

