-- X-WIndows/Borland Style widgets

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style


-- colors for controls
constant    z = WHITE,
            r = GRAY,
            w = BRIGHT_WHITE,
            g = GRAY

integer b
    b = BLACK

object result

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color for black
    -- gray if dim

    if dim then
        b = GRAY
    else
        b = BLACK
    end if

end procedure


-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
                integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio button, borland/x-windows

    integer x1, y1
    
    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    x1 = (col)*cWide
    y1 = ((row-1)*cTall)

    if check then
        pixel( { z,z,z,z,z,z,g,z,z,z,z,z,z }, {x1, y1+0} )
        pixel( { z,z,z,z,z,g,z,w,z,z,z,z,z }, {x1, y1+1} )
        pixel( { z,z,z,z,g,z,z,z,w,z,z,z,z }, {x1, y1+2} )
        pixel( { z,z,z,g,z,z,z,z,z,w,z,z,z }, {x1, y1+3} )
        pixel( { z,z,g,z,z,z,b,z,z,z,w,z,z }, {x1, y1+4} )
        pixel( { z,g,z,z,z,b,b,b,z,z,z,w,z }, {x1, y1+5} )
        pixel( { g,z,z,z,b,b,b,b,b,z,z,z,w }, {x1, y1+6} )
        pixel( { z,g,z,z,z,b,b,b,z,z,z,w,z }, {x1, y1+7} )
        pixel( { z,z,g,z,z,z,b,z,z,z,w,z,z }, {x1, y1+8} )
        pixel( { z,z,z,g,z,z,z,z,z,w,z,z,z }, {x1, y1+9} )
        pixel( { z,z,z,z,g,z,z,z,w,z,z,z,z }, {x1, y1+10} )
        pixel( { z,z,z,z,z,g,z,w,z,z,z,z,z }, {x1, y1+11} )
        pixel( { z,z,z,z,z,z,w,z,z,z,z,z,z }, {x1, y1+12} )

    else
        pixel( { z,z,z,z,z,z,w,z,z,z,z,z,z }, {x1, y1+0} )
        pixel( { z,z,z,z,z,w,z,g,z,z,z,z,z }, {x1, y1+1} )
        pixel( { z,z,z,z,w,z,z,z,g,z,z,z,z }, {x1, y1+2} )
        pixel( { z,z,z,w,z,z,z,z,z,g,z,z,z }, {x1, y1+3} )
        pixel( { z,z,w,z,z,z,z,z,z,z,g,z,z }, {x1, y1+4} )
        pixel( { z,w,z,z,z,z,z,z,z,z,z,g,z }, {x1, y1+5} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+6} )
        pixel( { z,w,z,z,z,z,z,z,z,z,z,g,z }, {x1, y1+7} )
        pixel( { z,z,w,z,z,z,z,z,z,z,g,z,z }, {x1, y1+8} )
        pixel( { z,z,z,w,z,z,z,z,z,g,z,z,z }, {x1, y1+9} )
        pixel( { z,z,z,z,w,z,z,z,g,z,z,z,z }, {x1, y1+10} )
        pixel( { z,z,z,z,z,w,z,g,z,z,z,z,z }, {x1, y1+11} )
        pixel( { z,z,z,z,z,z,g,z,z,z,z,z,z }, {x1, y1+12} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
                 integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box, borland/x-windows style

    integer x1, y1, x2, y2, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    x1 = (col)*cWide
    x2 = x1+12
    y1 = ((row-1)*cTall)
    y2 = y1+12

    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    x1 = (col)*cWide
    y1 = ((row-1)*cTall)

    if check then
        pixel( { w,w,w,w,w,w,w,w,w,w,w,w,z }, {x1, y1+0} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+1} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+2} )
        pixel( { w,z,z,z,z,z,z,z,z,b,b,z,g }, {x1, y1+3} )
        pixel( { w,z,z,z,z,z,z,z,b,b,z,z,g }, {x1, y1+4} )
        pixel( { w,z,z,b,z,z,z,b,b,z,z,z,g }, {x1, y1+5} )
        pixel( { w,z,b,b,z,z,b,b,z,z,z,z,g }, {x1, y1+6} )
        pixel( { w,z,b,b,z,b,b,z,z,z,z,z,g }, {x1, y1+7} )
        pixel( { w,z,b,b,b,b,z,z,z,z,z,z,g }, {x1, y1+8} )
        pixel( { w,z,b,b,b,z,z,z,z,z,z,z,g }, {x1, y1+9} )
        pixel( { w,z,g,g,z,z,z,z,z,z,z,z,g }, {x1, y1+10} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+11} )
        pixel( { z,g,g,g,g,g,g,g,g,g,g,g,z }, {x1, y1+12} )
    else
        pixel( { w,w,w,w,w,w,w,w,w,w,w,w,z }, {x1, y1+0} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+1} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+2} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+3} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+4} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+5} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+6} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+7} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+8} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+9} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+10} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g }, {x1, y1+11} )
        pixel( { z,g,g,g,g,g,g,g,g,g,g,g,z }, {x1, y1+12} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title, integer col1, integer row1, 
                integer wide, integer pressed, integer dim, integer hot,
                integer is_focus, integer focus )

    -- draw a button

    integer x1, y1, x2, y2, center, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    x1 = (col1-2)*cWide
    x2 = (col1+wide-2)*cWide
    y1 = ((row1-1)*cTall)-3
    y2 = ((row1)*cTall)+1

    -- button face
    polygon( WHITE, 1, {{x1, y1}, {x2, y1}, {x2, y2}, {x1, y2} } )

    -- title
    center = floor( (wide/2) - (length(title)/2)-1 )
    graphic_title( title, {b, WHITE}, row1, col1+center, hot, is_focus )

    -- focus?
    if focus then
            -- band around button
            polygon( BLACK, 0, {{x1, y1}, {x2,y1}, {x2, y2}, {x1, y2}} )

            -- shrink button
            x1 = x1 + 1
            y1 = y1 + 1
            x2 = x2 - 1
            y2 = y2 - 1

    end if

    -- top reflection
    if pressed then
        color = GRAY
    else
        color = BRIGHT_WHITE
    end if

    draw_line( color, { {x1, y2-1}, {x1, y1}, {x2, y1} } )

    -- optional shadow
    if pressed then
        draw_line( GRAY, {{x1+1, y2-1}, {x1+1, y1+1}, {x2-2, y1+1}} )
    end if

    -- bottom light shadow
    draw_line( GRAY, {{x1+1, y2-1}, {x2-1, y2-1}, {x2-1, y1-1}} )

    -- bottom dark shadow
    draw_line( BLACK, {{x1, y2}, {x2, y2}, {x2, y1}} )
    
    -- show mouse
    mouse_pointer(1)
    
end procedure


-----------------------------------------------------------------------------
global procedure graphic_box( integer row, integer col, integer show )

    integer x, y

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    x = col*cWide
    y = row*cTall

    if show = 0 then
        -- erase it
        polygon( WHITE, 1, {{x+1,y},
                            {x+cTall-1,y},
                            {x+cTall-1,y+(cWide*2)},
                            {x+1,y+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    -- BLACK surrounding
    polygon( BLACK, 0, {{x,y},
                        {x,y+(cWide*2)},
                        {x+cTall,y+(cWide*2)},
                        {x+cTall,y}} )
    
    -- top reflection
    draw_line( BRIGHT_WHITE, {{x+1,y+1},{x+cTall-1,y+1}})
    
    -- left reflection
    draw_line( BRIGHT_WHITE, {{x+1,y+1},{x+1,y+(cWide*2)-2}})    
    
    -- bottom shadow
    draw_line( GRAY, {{x+2,y+(cWide*2)-2},{x+cTall-2,y+(cWide*2)-2}})    
    draw_line( GRAY, {{x+1,y+(cWide*2)-1},{x+cTall-2,y+(cWide*2)-1}})    
    
    -- right shadow
    draw_line( GRAY, {{x+cTall-2,y+2},{x+cTall-2,y+(cWide*2)-1}})
    draw_line( GRAY, {{x+cTall-1,y+1},{x+cTall-1,y+(cWide*2)-1}})
    
    -- face
    polygon( WHITE, 1, {{x+2,y+2},
                        {x+cTall-3,y+2},
                        {x+cTall-3,y+(cWide*2)-3},
                        {x+2,y+(cWide*2)-3}} )

    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    integer x, y

    -- the box
    graphic_box( row, col, show )

end procedure

----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer x1, y1, x2, y2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        x1 = (col-1)*cWide
        y1 = (row)*cTall

        x2 = x1+(2*cWide)
        y2 = y1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{x1,y1},{x2,y1},{x2,y2},{x1,y2}} )

        -- scroll bar
        polygon( WHITE, 1, {{x1+1,y1+1},
                            {x2-1,y1+1},
                            {x2-1,y2-1},
                            {x1+1,y2-1}} )

    -- the up arrow
        -- box
        graphic_box( row, col-1, 1 )
    
        -- up arrow
        polygon( BLACK, 1, {{x1+7, y1+6},
                            {x1+4, y1+9},
                            {x1+11,y1+9},
                            {x1+8, y1+6}} )

    -- the down arrow
        -- box
        graphic_box( row+deep-1, col-1, 1 )
    
        -- convert to points
        y1 = (row+deep-1)*cTall
    
        -- down arrow
        polygon( BLACK, 1, {{x1+4, y1+6},
                            {x1+11,y1+6},
                            {x1+8, y1+9},
                            {x1+7, y1+9}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer x1, y1, x2, y2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        x1 = (col)*cWide-1
        y1 = (row)*cTall-1

        x2 = x1+((wide-1)*cWide)+1
        y2 = y1+(deep*cTall)+1

        -- draw it
        polygon( BLACK, 0, {{x1,y1},{x2,y1},{x2,y2},{x1,y2}} )

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer x1, y1, x2, y2

    -- hide mouse
    mouse_pointer(0)

    -- draw a slab

    -- adjust to points
    x1 = (col1*cWide)-4
    x2 = ((col1+wide-1)*cWide)+4
    y1 = ((row1-1)*cTall) 
    y2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{x1,y1-2},{x2,y1-2},{x2,y2},{x1,y2}})

    -- reflection
    draw_line( BRIGHT_WHITE, {{x1+1, y2-1}, {x1+1, y1-1}, {x2, y1-1}} )

    -- facet shadow
    draw_line( GRAY, {{x2-1, y1-1}, {x2-1, y2-1}, {x1+1, y2-1}} )

    -- shadow
    draw_line( BLACK, {{x2,y1-1}, {x2, y2}, {x1+1, y2}} )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer x1, y1, x2, y2, x, y, center
    integer borderThick, n

    borderThick = 7

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    x1 = col1*cWide
    x2 = (col1+wide)*cWide
    y1 = ((row1)*cTall)
    y2 = ((row1+deep-1)*cTall)
    
    -- window
    polygon( color, 1, {{x1-4,y1-18},
                        {x2+4,y1-18},
                        {x2+4,y2+4},
                        {x1-4,y2+4}}) 
                        
    -- window border
    polygon( BLACK, 0, {{x1-5,y1-19},
                        {x2+5,y1-19},
                        {x2+5,y2+5},
                        {x1-5,y2+5}})    
                        
    -- window reflection
    draw_line( BRIGHT_WHITE, {{x1-4,y2+4},
                               {x1-4,y1-18},
                               {x2+4,y1-18}} )
    
    -- window shadow
    draw_line( GRAY, {{x2+4,y1-17},
                              {x2+4,y2+4},
                              {x1-3,y2+4}})

    -- title
    graphic_text( row1, col1+1, BLACK, color, title )

    -- workspace                        
    polygon( WHITE, 1, {{x1,y1},{x2,y1},{x2,y2},{x1,y2}})    

    -- workspace border
    polygon( GRAY, 0, {{x1-1,y1-1},{x2+1,y1-1},{x2+1,y2+1},{x1-1,y2+1}})    

    -- left and top shadow
    draw_line( GRAY, {{x1-2,y2+1},
                      {x1-2,y1-2},
                      {x2+1,y1-2}})    

    -- right and bottom reflection
    draw_line( BRIGHT_WHITE, {{x2+2,y1-1},
                              {x2+2,y2+2},
                              {x1-1,y2+2}}) 

    -- show mouse
    mouse_pointer(1)

end procedure      
