-- Common Dialogs
--  Help 

include dialog.e

global procedure help_dialog( sequence title, sequence text )

    -- help dialog

    integer col
    sequence ofText, ofBorder

    -- save colors
    ofText = OF_TEXT
    ofBorder = OF_BORDER

    -- use different colors
    OF_TEXT = OF_DIALOG
    OF_BORDER = OF_DIALOG

    -- put stuff in the box
    new_dialog( title, 0, 0, 72, 21, {} )

    -- #1 help text
    add_control( 1, MLE, "", 3, 2, 68, 14, {READ_ONLY} )
    set_attrib( 1, ITEMS, text )

    -- #2 ok
    col = floor( (72 - 8)/2 )
    add_control( 2, BUTTON, "&OK", 19, col, 8, 0, {DEFAULT_BUTTON, FOCUS} )

    -- run the dialog
    run_dialog()

    -- restore screen
    hide_dialog()

    -- restore colors
    OF_TEXT = ofText
    OF_BORDER = ofBorder

end procedure

