-- Message Box
-- Common Dialog

include dialog.e

global procedure message_box( sequence title, sequence prompt )

    integer keyPress, wide, items, col

    -- was a single line passed, or multiple lines?
    if atom( prompt[1] ) then

        -- single line
        items = 1

        -- make into list
        prompt = { prompt }

    end if

    -- count lines
    items = length( prompt )

    -- find widest
    wide = 0

    -- scan through items
    for i = 1 to items do
        -- widest so far?
        if wide < length( prompt[i] )  then
            wide = length( prompt[i] )
        end if
    end for

    -- add 2 to each side
    wide = wide + 4

    -- put stuff in the box
    new_dialog( title, 0, 0, wide, 5+items, {} )

    -- ok button
    col = floor( (wide/2) - ( 8 / 2 ) )
    add_control( 1, BUTTON, "&OK", 3+items, col, 8, 0, {DEFAULT_BUTTON, FOCUS} )

    -- message
    for i = 1 to items do

        -- #n label
        col = floor( (wide/2) - ( length( prompt[i] ) / 2 ) )
        add_control( i+1, LABEL, prompt[i], i+1, col, 0, 0, {} )

    end for

    -- run dialog
    run_dialog()

    -- restore screen
    hide_dialog()

end procedure
