-- Example of using an SLE

    -- returns text or -1

without warning

include dialog.e

function ask_pizza()
    
    integer keyPress
    object result

    -- put stuff in the box    
    new_dialog( "What Is Your Favorite Pizza?", 0, 0, 46, 7, {} )

    -- populate dialog
    -- Note the label is used to put the text over the dialog
    -- instead of in front of it (the default)
    add_control( 1, LABEL, "What is your favorite pizza?", 2, 2, 0, 0, {} )
    add_control( 2, SLE, "", 3, 2, 42, 0, {} )
    add_control( 3, BUTTON, "&OK", 5, 3, 8, 0, {DEFAULT_BUTTON, FOCUS} )
    add_control( 4, BUTTON, "&Cancel", 5, 19, 10, 0, {CANCEL_BUTTON} )

    -- put default value into sle
    set_attrib( 2, DATA, "Pepperoni" )

    -- display the objects
    run_dialog()

    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        -- return value in reply
        result = get_attrib( 2, DATA )
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result


end function

-- run the dialog

    object result

    result = ask_pizza()

    if graphics_mode(-1) then end if

    if compare( result, -1 ) != 0 then
        puts( 1, "You said " & result & ".\n" )
    else
        puts( 1, "You cancelled the dialog.\n" )
    end if


