-- Example of using a Multi Line Edit

    -- returns text or -1

without warning

include dialog.e

function ask_pizza()
    
    integer keyPress
    object result

    -- put stuff in the box    
    new_dialog( "Enter Some Text", 0, 0, 35, 13, {} )

    -- populate dialog
    add_control( 1, MLE, "&Enter Text Here:", 3, 2, 30, 6, {} )
    add_control( 2, BUTTON, "&OK", 11, 4, 8, 0, {DEFAULT_BUTTON, FOCUS} )
    add_control( 3, BUTTON, "&Cancel", 11, 19, 10, 0, {CANCEL_BUTTON} )

    -- add default information
    set_attrib( 1, ITEMS, {
        "This is a Single Line Edit.",
        "Enter your information here." } )

    -- display the objects
    run_dialog()

    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        -- return value in reply
        result = get_attrib( 1, ITEMS )
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result


end function

-- run the dialog

    object result

    -- run dialog
        result = ask_pizza()

    -- restore resolution
        if graphics_mode(-1) then
        end if

    -- show result
        clear_screen()
        if compare( result, -1 ) != 0 then
            puts( 1, "You said:\n" )
            for i = 1 to length( result ) do
                puts( 1, result[i] & "\n" )
            end for
        else
            puts( 1, "You cancelled the dialog.\n" )
        end if

