-- small demo of dot's features
--

-- the screen
constant
    Screen      = 1,        -- the screen
    End         = -9999     -- used to detect 'End' argument in slice()


-----------------------------------------------------------------------------
function slice( sequence s, integer i1, integer i2 )
    -- return a slice of a sequence.

    -- does i2 contain 'End'?
    if i2 < -1 then
        -- calculate 'End'
        i2 = i2 - End + length( s )
    end if          

    return s[i1..i2]
    
end function


-----------------------------------------------------------------------------
-- simple demo
sequence s
s = "123456"

-- loop
for i = 1 to s.length() do

    -- write to screen
    Screen.puts( s & "\n" )

    -- shrink sequence size
    s.slice( 1, End-1 )

end for
